
# ========================================================
# Exemples d'estimations de modle  quations simultanes
# ========================================================

# on utilise la commande "systemfit" du package "systemfit"
# ce qui ncessite qu'il soit pralablement install

# lecture des donnes puis estimations du modle de Klein
klein = read.table("data.csv", header=TRUE, sep=";", dec=",")
attach(klein)

klein # pour voir les donnes
# fix(klein) pour les diter (refermer la fentre d'dition pour poursuivre)

library(systemfit) # pour charger le package "systemfit" suppos dj install

# help(systemfit) si on veut lire l'aide de la commande "systemfit"

# equations
conso =  cons ~ p + plag + wtot
wage = wpri ~ x + xlag + year
invest = inv ~ p + plag + klag
modklein = list(consommation = conso, salaires = wage, investissement = invest)

# estimations par les mco
fitols = systemfit(modklein)
summary(fitols)

# estimations par la mthode "sur"
fitsur = systemfit(modklein, "SUR")
summary(fitsur)

# estimations par les doubles moindres carrs
inst = ~ klag + plag + xlag + wpub + g + tax + year
fitdmc = systemfit(modklein, "2SLS", inst=inst)
summary(fitdmc)

# estimations par les doubles moindres carrs
# avec instruments diffrents
inst1 = ~ klag + plag + xlag + tax + year
inst2 = ~ klag + plag + xlag + wpub + g + tax + year
inst3 = ~ klag + plag + xlag + wpub + g + tax
instlist = list(inst1, inst2, inst3)
fitdmc2 = systemfit(modklein, "2SLS", inst=instlist)
summary(fitdmc2)

# estimations par les triples moindres carrs
inst = ~ klag + plag + xlag + wpub + g + tax + year
fittmc = systemfit(modklein, "3SLS", inst=inst)
summary(fittmc)
